module.exports = {
    env: {
        browser: true,
        es6: true,
        node: true
    },
    extends: 'eslint:recommended',
    parserOptions: {
        ecmaVersion: 2015,
        sourceType: 'module'
    },
    rules: {
        // disable unnecessary recommended rules
        'no-console': 0,
        'no-constant-condition': 0,

        // best practices
        'accessor-pairs': 2,
        'array-callback-return': 2,
        'consistent-return': 2,
        'dot-location': [2, 'property'],
        'eqeqeq': [2, 'smart'],
        'no-caller': 2,
        'no-global-assign': 2,
        'no-extend-native': 2,
        'no-extra-bind': 2,
        'no-extra-label': 2,
        'no-invalid-this': 2,
        'no-iterator': 2,
        'no-labels': 2,
        'no-lone-blocks': 2,
        'no-loop-func': 2,
        'no-new': 2,
        'no-new-wrappers': 2,
        'no-proto': 2,
        'no-return-assign': 2,
        'no-return-await': 2,
        'no-self-compare': 2,
        'no-sequences': 2,
        'no-throw-literal': 2,
        'no-void': 2,
        'no-unused-expressions': 2,
        'no-unsafe-negation': 2,
        'no-useless-call': 2,
        'no-useless-concat': 2,
        'no-useless-return': 2,
        'no-with': 2,
        'prefer-promise-reject-errors': 2,
        'yoda': 2,
        'require-atomic-updates': 2,

        // ES
        'no-var': 2,
        'prefer-const': 2,
        'arrow-body-style': 2,
        'arrow-parens': [2, 'as-needed', {'requireForBlockBody': true}],
        'arrow-spacing': 2,
        'generator-star-spacing': 2,
        'no-confusing-arrow': 2,
        'no-duplicate-imports': 2,
        'no-useless-computed-key': 2,
        'no-useless-constructor': 2,
        'no-useless-rename': 2,
        'object-shorthand': 2,
        'prefer-arrow-callback': 2,
        'prefer-numeric-literals': 2,
        'prefer-rest-params': 2,
        'prefer-spread': 2,
        'prefer-template': 2,
        'rest-spread-spacing': 2,
        'yield-star-spacing': 2,
        'template-tag-spacing': 2,

        // variables
        'no-shadow-restricted-names': 2,
        'no-undef-init': 2,
        'no-use-before-define': [2, 'nofunc'],

        // node-related
        'global-require': 2,
        'handle-callback-err': 2,
        'no-buffer-constructor': 2,
        'no-mixed-requires': 2,
        'no-new-require': 2,
        'no-path-concat': 2,
        'no-process-exit': 2,

        // stylistic issues
        'indent': [2, 4, {'flatTernaryExpressions': true}],
        'linebreak-style': [2, 'unix'],
        'quotes': [2, 'single'],
        'semi': [2, 'always'],
        'array-bracket-spacing': 2,
        'block-spacing': 2,
        'brace-style': [2, '1tbs', {'allowSingleLine': true}],
        'camelcase': 2,
        'comma-spacing': 2,
        'comma-style': 2,
        'eol-last': 2,
        'func-call-spacing': 2,
        'func-name-matching': 2,
        'implicit-arrow-linebreak': 2,
        'key-spacing': 2,
        'keyword-spacing': 2,
        'new-cap': 2,
        'new-parens': 2,
        'no-array-constructor': 2,
        'no-empty': 2,
        'no-lonely-if': 2,
        'no-new-object': 2,
        'no-mixed-spaces-and-tabs': 2,
        'no-trailing-spaces': 2,
        'no-unneeded-ternary': 2,
        'object-curly-spacing': 2,
        'operator-linebreak': [2, 'after'],
        'semi-spacing': 2,
        'space-before-blocks': 2,
        'space-before-function-paren': [2, {'anonymous': 'always', 'named': 'never'}],
        'space-in-parens': 2,
        'space-infix-ops': 2,
        'space-unary-ops': 2,
        'switch-colon-spacing': 2
    }
};
